<template>
    <v-card>
        <v-card-title class="headline">{{ $t("title") }}</v-card-title>
        <v-form ref="modifyPassword">
            <v-card-text>
                <v-container>
                    <v-text-field 
                        v-model="oldPassword" 
                        type="password" 
                        v-bind:label="$t('old-password')" 
                        :rules="[rules.required, rules.password]" 
                        @keyup.enter="submit" 
                        required
                    ></v-text-field>
                    <p v-if="error" style="color: red">{{ $t('error-log') }}</p>
                    <v-text-field 
                        v-model="password" 
                        type="password" 
                        v-bind:label="$t('password')" 
                        :rules="[rules.required, rules.password]" 
                        @keyup.enter="submit" 
                        required
                    ></v-text-field>
                    <p class="pass-info">{{ $t('password-l1')}}</p>
                    <p class="pass-info" :class="password && password.length > 7 ? 'correct' : 'incorrect'">{{ $t('password-l2')}}</p>
                    <p class="pass-info" :class="password && /[A-Z]/gm.test(password) ? 'correct' : 'incorrect'">{{ $t('password-l3')}}</p>
                    <p class="pass-info" :class="password && /[a-z]/gm.test(password) ? 'correct' : 'incorrect'">{{ $t('password-l4')}}</p>
                    <p class="pass-info" :class="password && /[0-9]/gm.test(password) ? 'correct' : 'incorrect'">{{ $t('password-l5')}}</p>
                    <p class="pass-info" :class="password && /[.!#$%&'*+/=?^_`{|}~-]/gm.test(password) ? 'correct' : 'incorrect'">{{ $t('password-l6')}}</p>
                    <v-text-field 
                        v-model="password2" 
                        type="password" 
                        v-bind:label="$t('password-confirm')" 
                        :rules="[rules.passwordMatch, rules.required]" 
                        @keyup.enter="submit" 
                        required
                    ></v-text-field>
                </v-container>
            </v-card-text>
            <v-card-actions>
                <v-btn color="normal" class="ma-2" @click="cancel">{{ $t("cancel") }}</v-btn>
                <v-spacer></v-spacer>
                <v-btn color="primary" class="ma-2" @click="submit">{{ $t("submit") }}</v-btn>
            </v-card-actions>
        </v-form>
    </v-card>
</template>

<script>
    import APIUser from "@/api/UserAPI.js";

    const apiUser = new APIUser();

    export default {
        name: "ModifyPassword",
        data () {
            return {
                user: Object.assign({}, JSON.parse(localStorage.getItem("user"))),
                oldPassword: "",
                password: "",
                password2: "",
                rules: {
                    required: v => !!v || this.$t("required"),
                    passwordMatch: () => this.password === this.password2 || this.$t("password-match"),
                    password: (pass) => (pass && pass.length > 7 && /[A-Z]/gm.test(pass) && /[a-z]/gm.test(pass) && /[0-9]/gm.test(pass) && /[.!#$%&'*+/=?^_`{|}~-]/gm.test(pass)) || this.$t("password-criteria"),
                },
                error: false,
            };
        },
        methods: {
            async submit() {
                try {
                    if(this.$refs.modifyPassword.validate()) {
                        console.log("Submit");
                        let data = await apiUser.updateUser({
                            _id: this.user._id,
                            oldPassword: this.oldPassword,
                            password: this.password,
                        });
                        this.error = false;
                        localStorage.setItem("user", JSON.stringify(data.data));
                        this.$refs.modifyPassword.reset();
                        this.$noty.success(this.$t("password-changed"));
                        this.$emit("exit", "modifyPassword");
                    }
                } catch (err) {
                    console.error(`Error has occured : ${err}`);
                    this.error = true;

                }
            },
            cancel () {
                this.$refs.modifyPassword.reset();
                this.$emit("exit", "modifyPassword");
            },
        },
    };
</script>

<style scoped>
    .mainContent
    {
        margin-top: 2%;
    }

    .pass-info {
        font-size: 0.9em;
    }

    .pass-info.incorrect {
        color: red;
    }

    .pass-info.correct {
        color: green;
    }
</style>

<i18n>
{
    "en": {
        "title": "Modify my password",
        "password-match": "Passwords must be the same",
        "password-criteria": "Respect all criterias",
        "password-confirm": "Confirm password",
        "old-password": "Old passowrd",
        "password-l1" : "Your password must be composed of at least :",
        "password-l2" : "- 8 characters",
        "password-l3" : "- one upper case character",
        "password-l4" : "- one lower case character",
        "password-l5" : "- one number",
        "password-l6" : "- one special character (. ! # $ % & ' * + / = ? ^ _ ` { | } ~ -)",
        "error-log": "Incorrect old password",
        "password-changed": "Password changed !"
    },
    "fr": {
        "title": "Modifier mon mot de passe",
        "password-match": "Les mots de passes doivent correspondre",
        "password-criteria": "Le mot de passe doit respecter les règles suivantes",
        "password-confirm": "Confirmer le mot de passe",
        "old-password": "Ancien mot de passe",
        "password-l1" : "Votre mot de passe doit être composé d'au moins :",
        "password-l2" : "- 8 caractères",
        "password-l3" : "- une lettre majuscule",
        "password-l4" : "- une lettre minuscule",
        "password-l5" : "- un chiffre",
        "password-l6" : "- un caractère spécial (. ! # $ % & ' * + / = ? ^ _ ` { | } ~ -)",
        "error-log": "Ancien mot de passe incorrect",
        "password-changed": "Mot de passe changé !"
    }
}
</i18n>